@echo off
cls
rem ***************************************************************************
rem to show syntax type build -h or to read go at syntax label
rem ***************************************************************************

rem ***************************************************************************
rem Set variables
rem ***************************************************************************
Set Tpath=%PATH%
Set HmgPath=D:\Minigui30
Set Path=%PATH%;%HmgPath%\util;%HmgPath%\mingw\bin;%HmgPath%\harbour\bin;
Set Resources=%HmgPath%\resources\minigui.o

set GT=-gtgui
set DEBUG=""
set BUILDTYPE=""
set REBUILDALL=""
set RUN=.F.
set MT=
set showlog=0
set buildlib=0
set l3wresource=D:\SVIHMG20\LfSystem\LfResource\stdimage.rc

rem ***************************************************************************
rem Parameters Processing
rem ***************************************************************************
:getprm

rem ---------------------------------------------------------------------------
rem /h parameter: show syntax help
rem ---------------------------------------------------------------------------
if "%1"=="" goto syntax
if "%1"=="/?" goto syntax
if "%1"=="-?" goto syntax
if "%1"=="/h" goto syntax
if "%1"=="/H" goto syntax
if "%1"=="-h" goto syntax
if "%1"=="-H" goto syntax
if "%1"=="-help" goto syntax
if "%1"=="-HELP" goto syntax

rem ---------------------------------------------------------------------------
rem /x parameter: run required after compiling
rem ---------------------------------------------------------------------------
if "%1"=="/x" goto runyes
if "%1"=="/X" goto runyes

rem ---------------------------------------------------------------------------
rem /i parameter: incremental build
rem ---------------------------------------------------------------------------
if "%1"=="/i" goto incremental
if "%1"=="/I" goto incremental

rem ---------------------------------------------------------------------------
rem /r parameter: Procedure increbuild
rem ---------------------------------------------------------------------------
if "%1"=="/r" goto increbuild
if "%1"=="/R" goto increbuild

rem ---------------------------------------------------------------------------
rem /d parameter: Procedure Debug
rem ---------------------------------------------------------------------------
if "%1"=="/d" goto debug
if "%1"=="/D" goto debug

rem ---------------------------------------------------------------------------
rem Multi Thread
rem ---------------------------------------------------------------------------
if "%1"=="/mt" goto multithread
if "%1"=="/MT" goto multithread

rem ---------------------------------------------------------------------------
rem Console Incremental Rebuild
rem ---------------------------------------------------------------------------
if "%1"=="/cr" goto consoleincrebuild
if "%1"=="/CR" goto consoleincrebuild

rem ---------------------------------------------------------------------------
rem /ci parameter: Procedure IncConsole
rem ---------------------------------------------------------------------------
if "%1"=="/ci" goto consoleincremental
if "%1"=="/CI" goto consoleincremental

rem ---------------------------------------------------------------------------
rem /cs parameter: Procedure Console
rem ---------------------------------------------------------------------------
if "%1"=="/cs" goto console
if "%1"=="/CS" goto console

rem ---------------------------------------------------------------------------
rem /bl parameter: build library
rem ---------------------------------------------------------------------------
if "%1"=="/bl" goto buildlib
if "%1"=="/BL" goto buildlib

goto building

rem ***************************************************************************
rem /x parameter: run required after compiling
rem ***************************************************************************
:runyes
set RUN=.T.
shift
goto getprm

rem ***************************************************************************
rem /i parameter: incremental build
rem ***************************************************************************
:incremental
set BUILDTYPE=-inc -head=native
shift
goto getprm

rem ***************************************************************************
rem /r parameter: Procedure increbuild
rem ***************************************************************************
:increbuild
set BUILDTYPE=-inc
set REBUILDALL=-rebuild
shift
goto getprm

rem ***************************************************************************
rem Procedure Debug
rem ***************************************************************************
:debug
set GT=-gtwin
set DEBUG=-b
echo Options NoRunAtStartup > Init.cld
shift
goto getprm

rem ***************************************************************************
rem /mt parameter: Procedure Multithread
rem ***************************************************************************
:multithread
set MT=-mt
shift
goto getprm

rem ***************************************************************************
rem /cr parameter: Procedure IncConsole Rebuild
rem ***************************************************************************
:consoleincrebuild
set BUILDTYPE=-inc
set GT=-gtwin
set REBUILDALL=-rebuild
shift
goto getprm

rem ***************************************************************************
rem /ci parameter: Procedure IncConsole
rem ***************************************************************************
:consoleincremental
set BUILDTYPE=-inc
set GT=-gtwin
shift
goto getprm

rem ***************************************************************************
rem /cs parameter: Procedure Console
rem ***************************************************************************
:console
set GT=-gtwin
shift
goto getprm

rem ***************************************************************************
rem /bl parameter: build library
rem ***************************************************************************
:buildlib
set buildlib=1
shift
goto getprm

rem ***************************************************************************
rem /h help
rem ***************************************************************************
:syntax
cls
echo ***************************************************************************
echo Syntax:
echo.
echo "Build [/x | /i | /r | /d | /cs | /ci | /cr | /bl] <PrgFile> | <filelist.hbp> [config.hbc]"
echo.
echo [/x] : run after build
echo.
echo [/i] : incremental build
echo [/r] : incremental build (rebuild all)
echo.
echo [/d] : Debug mode (gui and console)
echo.
echo [/cs] : Console/mixed mode (std build)
echo [/ci] : Console/mixed mode (incremental build)
echo [/cr] : Console/mixed mode (incremental rebuild all)
echo.
echo [/bl] : build library
echo.
echo filelist.hbm : A text file with .hbp extension containing a source list
echo configfile.hbc: A text file with configuration parameters as additional
echo libs, include paths and lib paths.
echo.
echo  configfile.hbc Syntax:
echo.
echo  incpaths = incpath1 incpath2 ... incpathn
echo.
echo  libpaths = libpath1 libpath2 ... libpathn
echo.
echo  libs = lib1 lib2 ... libn
echo.
echo  - library names must not include 'lib' prefix nor '.a' extension.
echo '.hbc' files in the current folder are automatically processed.
echo.
echo nbuild.bat will create an 'error.log' file in the app folder and
echo show if process ends with an error condition.
echo.
echo ***************************************************************************
pause
goto exit

rem ***************************************************************************
rem start building process
rem ***************************************************************************
:building
cls
echo building...

if exist hbmk.log del hbmk.log
if exist windres.log del windres.log
if exist error.log del error.log
if exist _hmg_resconfig.h del _hmg_resconfig.h
if exist Init.cld del Init.cld
if exist _temp.rc del _temp.rc
if exist _temp.o  del _temp.o

if exist %~n1.exe del %~n1.exe
if exist %~n1.exe goto error01

rem ***************************************************************************
rem If a resource with the same base name as the first parameter exist compile it
rem ***************************************************************************
if not exist %l3wresource% goto invoke
if exist %~n1.rc goto resspec
echo #define HMGRPATH %HmgPath%\RESOURCES > _hmg_resconfig.h
copy /b %HmgPath%\resources\minigui.rc+%l3wresource%+%HmgPath%\resources\filler _temp.rc >NUL
goto cmpres

:resspec
echo #define HMGRPATH %HmgPath%\RESOURCES > _hmg_resconfig.h
copy /b %HmgPath%\resources\minigui.rc+%l3wresource%+%~n1.rc+%HmgPath%\resources\filler _temp.rc >NUL
rem ---------------------------------------------------------------------------
rem if you have Vdm already loaded, use standard redirection else redir.exe
rem Comment and uncomment both lines
rem ---------------------------------------------------------------------------
:cmpres
windres -i _temp.rc -o _temp.o > windres.log 2>&1
rem redir -e windres.log windres -i _temp.rc -o _temp.o
if errorlevel 1 goto error02
Set Resources=_temp.o

rem ***************************************************************************
rem invoke HBMK2
rem ***************************************************************************
:invoke
rem ---------------------------------------------------------------------------
rem if you have Vdm already loaded, use standard redirection else redir.exe
rem Comment and uncomment both lines
rem ---------------------------------------------------------------------------
if %buildlib%==1 goto buildlibrary
hbmk2 -o%~n1.exe %GT% %DEBUG% %MT% %BUILDTYPE% %REBUILDALL% -incpath=%HmgPath%\include -L%HmgPath%\lib -lminigui -lhbmysql -lmysql -lcrypt -ledit -leditex -lgraph -lini -lreport -lhbwin -lhbziparc -lhbmzip -lmsvfw32 -lvfw32 -lsddodbc -lrddsql -lsddmy -lhbodbc -lodbc32 -lhbhpdf -lhbvpdf -lhbmemio -lhbsqlit3 -lsqlite3 -lhbfimage -lhbpgsql -lpq -lhbtip -lhbct -lhbmisc -lhbnetio -lxhb -prgflag=/q %1 %2 %3 %4 %5 %6 %7 %8 %9 %Resources%  >hbmk.log 2>&1
rem redir -eo  hbmk2 -o%~n1.exe %GT% %DEBUG% %MT% %BUILDTYPE% %REBUILDALL% -incpath=%HmgPath%\include -L%HmgPath%\lib -lminigui -lhbmysql -lmysql -lcrypt -ledit -leditex -lgraph -lini -lreport -lhbwin -lhbziparc -lhbmzip -lmsvfw32 -lvfw32 -lsddodbc -lrddsql -lsddmy -lhbodbc -lodbc32 -lhbhpdf -lhbvpdf -lhbmemio -lhbsqlit3 -lsqlite3 -lhbfimage -lhbpgsql -lpq -lhbtip -lhbct -lhbmisc -lhbnetio -lxhb -prgflag=/q %1 %2 %3 %4 %5 %6 %7 %8 %9 %Resources%  >hbmk.log
if errorlevel 1 goto error03
goto end

:buildlibrary
hbmk2 -hblib -o%~n1.o %GT% %DEBUG% %MT% %BUILDTYPE% %REBUILDALL% -incpath=%HmgPath%\include -L%HmgPath%\lib -lminigui -lhbmysql -lmysql -lcrypt -ledit -leditex -lgraph -lini -lreport -lhbwin -lhbziparc -lhbmzip -lmsvfw32 -lvfw32 -lsddodbc -lrddsql -lsddmy -lhbodbc -lodbc32 -lhbhpdf -lhbvpdf -lhbmemio -lhbsqlit3 -lsqlite3 -lhbfimage -lhbpgsql -lpq -lhbtip -lhbct -lhbmisc -lhbnetio -lxhb -prgflag=/q %1 %2 %3 %4 %5 %6 %7 %8 %9 %Resources%  >hbmk.log 2>&1
rem redir -eo  hbmk2 -hblib -o%~n1.exe %GT% %DEBUG% %MT% %BUILDTYPE% %REBUILDALL% -incpath=%HmgPath%\include -L%HmgPath%\lib -lminigui -lhbmysql -lmysql -lcrypt -ledit -leditex -lgraph -lini -lreport -lhbwin -lhbziparc -lhbmzip -lmsvfw32 -lvfw32 -lsddodbc -lrddsql -lsddmy -lhbodbc -lodbc32 -lhbhpdf -lhbvpdf -lhbmemio -lhbsqlit3 -lsqlite3 -lhbfimage -lhbpgsql -lpq -lhbtip -lhbct -lhbmisc -lhbnetio -lxhb -prgflag=/q %1 %2 %3 %4 %5 %6 %7 %8 %9 %Resources%  >hbmk.log
if errorlevel 1 goto error03
goto end

rem ***************************************************************************
rem I can't remove %1.exe
rem ***************************************************************************
:error01
echo :: I can't remove %1.exe >windres.log
set showlog=1
goto end

rem ***************************************************************************
rem windres error
rem ***************************************************************************
:error02
set showlog=1
goto end

rem ***************************************************************************
rem hbmk2 error
rem ***************************************************************************
:error03
set showlog=1
goto end

:end
rem ***************************************************************************
rem Delete temporary files
rem ***************************************************************************
if exist windres.log type windres.log > error.log
if exist hbmk.log type hbmk.log >> error.log
if exist hbmk.log del hbmk.log
if exist windres.log del windres.log
if exist _hmg_resconfig.h del _hmg_resconfig.h
if exist Init.cld del Init.cld
if exist _temp.rc del _temp.rc
if exist _temp.o  del _temp.o

rem ***************************************************************************
rem if there is error show log
rem ***************************************************************************
if %showlog%==0 goto runexe
:showlog
type error.log
pause
goto exit

rem ***************************************************************************
rem execute program if required
rem ***************************************************************************
:runexe
if exist error.log del error.log
if "%RUN%"==".T." if exist %~n1.exe %~n1.exe
goto exit

:exit
rem ***************************************************************************
rem UNset variables
rem ***************************************************************************
Set Path=%Tpath%
Set Tpath=
Set HmgPath=
Set Resources=

set GT=
set DEBUG=
set BUILDTYPE=
set REBUILDALL=
set RUN=
set MT=
set incpath=
set showlog=
set buildlib=
set l3wresource=